package lib.ui.reactive;

import kernel.Log;
import kernel.ButtonType;
import util.Vec.Vec2;

using tink.CoreApi;

abstract class UIElement {
	abstract public function render(bounds:Vec2<Int>):Canvas;
	public var changed(default, null):Signal<Noise>;
	private final changedTrigger:SignalTrigger<Noise> = Signal.trigger();

	public function new() {
		changed = changedTrigger.asSignal();
	}

	public function handleClickEvent(pos: Vec2<Int>,button: ButtonType):Void {
	}
}
